﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// MonoBehaviourista periytymisen sijasta laitetaan tämä skripti periytymään Kuoleminen-skriptistä.
public class VihollisenKuoleminen : Kuoleminen {

    // Muuttuja, joka määrittää paljonko pisteitä kyseisen vihollisen tuhoaminen tuottaa.
    public int pisteAnsio;

    // Periytyminen Kuoleminen-skriptistä vaatii tämän skriptin täyttämään sen julistaman Kuole-funktion.
    // Näkyvyys pysyy suojattuna, mutta abstrakti sanan tilalle kirjoitetaan override, eli päällekirjoitetaan
    // perityn skriptin funktio.
    protected override void Kuole()
    {
        // Vihollisen kuoltua lisätään pelaajan pisteisiin pisteAnsio-muuttujan verran.
        // Pääsemme Lisää-funktioon käsiksi helposti staattisen Pisteet-luokan instanssin kautta.
        Pisteet.instanssi.Lisää(pisteAnsio);
        
        // Poistetaan vihollinen maailmasta Destroy-funktiolla. Parametriksi vihollisen objekti.
        Destroy(gameObject);
    }

}

