﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// Tarvitsemme Unityn UI-resurssit käsitelläksemme UI-komponentteja
using UnityEngine.UI;

public class ElämäpisteetPalkki : MonoBehaviour {

    // Päästäksemme tämän skriptin Päivitä-funktioon helposti käsiksi, luodaan julkinen staattinen muuttuja instanssi.
    // Tämän muuttujan tyyppi on sama kuin tämän skriptin luokan nimi.  
    public static ElämäpisteetPalkki instanssi;

    // Tähän muuttujaan tallennamme viittauksen elämäpalkin etuosaan.
    public Image kuva;

	void Start () {
        // Tallennetaan viittaus tästä skripti-instanssista instanssi-muuttujaan.
        instanssi = this;
	}

    // Tämä funktio päivittää peliruudulla näkyvän elämäpistepalkin täyttyvyyden.
    public void Päivitä(float elämäpisteet)
    {
        // Koska Image-komponentin Fill Amount-kenttä hyväksyy vain arvoja väliltä 0-1, ja pelissämme elämäpisteet on esitetty väliltä 0-100,
        // täytyy meidän jakaa elämäpisteiden arvo luvulla 100.
        kuva.fillAmount = elämäpisteet / 100f;
    }

}
