﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// Tarvitsemme Unityn UI-resurssit käsitelläksemme UI-komponentteja
using UnityEngine.UI;

public class Kuolemavalikko : MonoBehaviour {

    // Päästäksemme tämän skriptin Näytä-funktioon helposti käsiksi, luodaan julkinen staattinen muuttuja instanssi.
    // Tämän muuttujan tyyppi on sama kuin tämän skriptin luokan nimi.  
    public static Kuolemavalikko instanssi;

    // Tähän muuttujaan tallennamme viittauksen kuolemavalikko-objektiin, jota käytämme valikon näyttämiseen.
    public GameObject kuolemavalikko;

    // Tähän muuttujaan tallennamme viittauksen valikossa sijaitsevan pistetekstiin.
    public Text pisteTeksti;

	void Start () {
        // Tallennetaan viittaus tästä skripti-instanssista instanssi-muuttujaan.
        instanssi = this;
	}

    // Tämä funktio laittaa valikon näkyviin peliruudulle.
    public void Näytä()
    {
        if (Pisteet.instanssi.PisteidenMäärä() > PlayerPrefs.GetInt("Pisteet"))
            PlayerPrefs.SetInt("Pisteet", Pisteet.instanssi.PisteidenMäärä());

        // Ennenkuin valikko laitetaan näkyviin, asetetaan valikon pistetekstin tekstiksi ansaittu pistemäärä.
        // Saamme pisteiden määrän helposti staattisen Pisteet-luokan instanssin kautta.
        pisteTeksti.text = "Pisteet: " + Pisteet.instanssi.PisteidenMäärä();

        // Lopuksi laitetaan valikko aktiiviseksi, mikä laittaa sen näkyviin ruudulle.
        kuolemavalikko.SetActive(true);
    }

}
