﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// Tarvitsemme Unityn UI-resurssit käsitelläksemme UI-komponentteja
using UnityEngine.UI;

public class Pisteet : MonoBehaviour {

    // Päästäksemme tämän skriptin Lisää-funktioon helposti käsiksi, luodaan julkinen staattinen muuttuja instanssi.
    // Tämän muuttujan tyyppi on sama kuin tämän skriptin luokan nimi.  
    public static Pisteet instanssi;

    // Tähän muuttujaan tallennamme viittauksen valikossa sijaitsevan pistetekstiin.
    public Text teksti;

    // Muuttuja, joka sisältää tiedon pelaajan ansaitsemien pisteiden määrästä.
    int pisteet;

	void Start () {
        // Tallennetaan viittaus tästä skripti-instanssista instanssi-muuttujaan.
        instanssi = this;
	}

    // Tämä funktio päivittää peliruudulla näkyvän pistetekstin näyttämään oikean pisteiden määrän samalla, kun pisteiden määrään lisätään pisteitä.
    public void Lisää(int määrä)
    {
        // Lisätään nykyisiin pisteisiin parametrin määrä arvo.
        pisteet += määrä;

        // Asetetaan peliruudun tekstille uusi pisteiden määrä. Koska teksti odottaa string-tyyppiä, täytyy int-muuttujamme arvo muuttaa tekstiksi
        // ToString-funktiolla.
        teksti.text = pisteet.ToString();
    }

    // Tämä funktio palauttaa pelaajan pisteiden määrän.
    public int PisteidenMäärä()
    {
        return pisteet;
    }

}
